
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "cell.h"
#include "csi.h"

extern void	Error(),RangeList(),ReadSliceImage(),chull3_();

static int	Append(i2,X,Y,x,y)
int		i2,*X,*Y,x,y;
{
	int	i1,x1,y1,x2=X[i2]-x,y2=Y[i2]-y;

	while ((i1=i2)>0) {
	    --i2; x1=x2; y1=y2; if ((x2=X[i2]-x)*y1<(y2=Y[i2]-y)*x1) break;
	}
	++i1; X[i1]=x; Y[i1]=y++; x1=0; y1=(-1);
	while ((i2=i1)>0) {
	    --i1; x2=x1; y2=y1; if ((x1=X[i1]-x)*y2<(y1=Y[i1]-y)*x2) break;
	}
	++i2; X[i2]=x; Y[i2]=y; return i2;
}

static int	FV3(X,Y,Z,fe,sv,ev,rf,sce,ece,f,v1,v2,v3)
int		*X,*Y,*Z,*fe,*sv,*ev,*rf,*sce,*ece,f,*v1,*v2,*v3;
{
	int		e=fe[f]-1;
	long long	x1,y1,z1,x2,y2,z2;

	if (f==rf[e]-1) {
	    *v1=ev[e]-1; *v2=sv[e]-1; e=sce[e]-1;
	}
	else {
	    *v1=sv[e]-1; *v2=ev[e]-1; e=ece[e]-1;
	}
	*v3=(f==rf[e]-1)?sv[e]-1:ev[e]-1;

	return (x1=X[*v1]-X[*v3])*(y2=Y[*v2]-Y[*v3])!=
	       (y1=Y[*v1]-Y[*v3])*(x2=X[*v2]-X[*v3]) ||
	       (z1=Z[*v1]-Z[*v3])*x2!=x1*(z2=Z[*v2]-Z[*v3]) || y1*z2!=z1*y2;
}

static void	PutN(file,ptr)
FILE		*file;
char		*ptr;
{
	(void)fwrite(ptr,(size_t)4,(size_t)1,file);
}

static void	PutR(file,ptr)
FILE		*file;
char		*ptr;
{
	char	c[4];

	c[0]=ptr[3]; c[1]=ptr[2]; c[2]=ptr[1]; c[3]=ptr[0]; PutN(file,c);
}

#define PV	(Cell)(~0)

int	main(argc,argv)
int	argc;
char	**argv;
{
	char	**paths,pv[(size_t)PV+1],**last;
	int	Nx,Ny,Nz,i,j,*Xl,*Yl,*Xr,*Yr,*X,*Y,*Z,y,x,V,z,l,r,L,R,N1,N2,
		*name,*ve,*fe,*sv,*ev,*rf,*lf,*sce,*scce,*ece,*ecce,
		*wv1,*wv2,*wv3,*wv4,*wv5,*wv6,*we1,*we2,*wf1,*wf2,
		para[10],F,v1,v2,v3,x1,x2,y1,y2,z1,z2;
	Cell	**cell;
	FILE	*file;
	float	w;

	short	s=1;
	char	*c=(char *)&s;
	void	(*Put)()=((short)*c==s)?PutN:PutR;

	if (argc!=5)
	    Error("usage : si_ch_zcp directory nameFile rangeList ZCP");

	paths=CheckSliceImages(argv[1],argv[2],&Nx,&Ny,&Nz,NULL);

	RangeList(argv[3],(size_t)PV,pv);

	i=Ny+1; j=i*2*(Nz+1);

	if ((last=(char **)malloc(sizeof(char *)*Ny))==NULL ||
	    (*last=(char *)malloc(sizeof(char)*Ny*Nx))==NULL ||
	    (cell=(Cell **)malloc(sizeof(Cell *)*Ny))==NULL ||
	    (*cell=(Cell *)malloc(sizeof(Cell)*Ny*Nx))==NULL ||
	    (Xl=(int *)malloc(sizeof(int)*i))==NULL ||
	    (Yl=(int *)malloc(sizeof(int)*i))==NULL ||
	    (Xr=(int *)malloc(sizeof(int)*i))==NULL ||
	    (Yr=(int *)malloc(sizeof(int)*i))==NULL ||
	    (X=(int *)malloc(sizeof(int)*j))==NULL ||
	    (Y=(int *)malloc(sizeof(int)*j))==NULL ||
	    (Z=(int *)malloc(sizeof(int)*j))==NULL)
	    Error("no allocatable memory for sampling points.");

	for (y=0; y<Ny; y++) {
	    if (y>0) {
		last[y]=last[y-1]+Nx; cell[y]=cell[y-1]+Nx;
	    }
	    for (x=0; x<Nx; x++) last[y][x]=0;
	}

#define APPEND()	if (i==0) { \
			    Xl[0]=Xl[1]=  l; Yl[0]=Yr[0]=y  ; \
			    Xr[0]=Xr[1]= -r; Yl[1]=Yr[1]=y+1; L=R=i=1; \
			} \
			else { \
			    L=Append(L,Xl,Yl, l,y); \
			    R=Append(R,Xr,Yr,-r,y); \
			}

#define STORE()	for (l=r=0; l<=L || r<=R; Z[V++]=z) \
		    if (r>R || (l<=L && Yl[l]<=Yr[r])) { \
			X[V]=  Xl[l]; Y[V]=Yl[l]; ++l; \
		    } \
		    else { \
			X[V]=1-Xr[r]; Y[V]=Yr[r]; ++r; \
		    }

	V=0;
	for (z=0; z<Nz; z++) {
	    ReadSliceImage(paths[z],Nx,Ny,cell);

	    i=0;
	    for (y=0; y<Ny; y++) {
		l=Nx;
		for (x=0; x<Nx; x++)
		    if (last[y][x]) {
			last[y][x]=pv[cell[y][x]]; if ((r=x)<l) l=x;
		    }
		    else if (pv[cell[y][x]]) {
			last[y][x]=1; if ((r=x)<l) l=x;
		    }

		if (l!=Nx) APPEND();
	    }
	    if (i!=0) STORE();
	}
	i=0;
	for (y=0; y<Ny; y++) {
	    l=Nx;
	    for (x=0; x<Nx; x++)
		if (last[y][x] && (r=x)<l) l=x;

	    if (l!=Nx) APPEND();
	}
	if (i!=0) STORE();

	if (V==0) Error("no object.");

	free(Yr); free(Xr); free(Yl); free(Xl);
	free(*cell); free(cell); free(*last); free(last);

	N1=V+1; N2=N1*3; i=N1*4;

	if ((X=(int *)realloc(X,sizeof(int)*N1))==NULL ||
	    (Y=(int *)realloc(Y,sizeof(int)*N1))==NULL ||
	    (Z=(int *)realloc(Z,sizeof(int)*N1))==NULL ||
	    (name=(int *)malloc(sizeof(int)*N1))==NULL ||
	    (ve=(int *)malloc(sizeof(int)*N1))==NULL ||
	    (fe=(int *)malloc(sizeof(int)*N2))==NULL ||
	    (sv=(int *)malloc(sizeof(int)*i))==NULL ||
	    (ev=(int *)malloc(sizeof(int)*i))==NULL ||
	    (rf=(int *)malloc(sizeof(int)*i))==NULL ||
	    (lf=(int *)malloc(sizeof(int)*i))==NULL ||
	    (sce=(int *)malloc(sizeof(int)*i))==NULL ||
	    (scce=(int *)malloc(sizeof(int)*i))==NULL ||
	    (ece=(int *)malloc(sizeof(int)*i))==NULL ||
	    (ecce=(int *)malloc(sizeof(int)*i))==NULL ||
	    (wv1=(int *)malloc(sizeof(int)*N1))==NULL ||
	    (wv2=(int *)malloc(sizeof(int)*N1))==NULL ||
	    (wv3=(int *)malloc(sizeof(int)*N1))==NULL ||
	    (wv4=(int *)malloc(sizeof(int)*N1))==NULL ||
	    (wv5=(int *)malloc(sizeof(int)*N1))==NULL ||
	    (wv6=(int *)malloc(sizeof(int)*N1))==NULL ||
	    (we1=(int *)malloc(sizeof(int)*i))==NULL ||
	    (we2=(int *)malloc(sizeof(int)*i))==NULL ||
	    (wf1=(int *)malloc(sizeof(int)*N2))==NULL ||
	    (wf2=(int *)malloc(sizeof(int)*N2))==NULL)
	    Error("no allocatable memory for convex hull.");

	for (i=0; i<V; i++) name[i]=i;

	para[0]=N1; chull3_(&V,X,Y,Z,name,para,
			    ve,fe,sv,ev,rf,lf,sce,scce,ece,ecce,
			    wv1,wv2,wv3,wv4,wv5,wv6,we1,we2,wf1,wf2);

	if (argv[4][0]=='-')
	    file=stdout;
	else
	    if ((file=fopen(argv[4],"wb"))==NULL) Error("file not stored.");

	V=0;
	for (i=0; i<N1; i++) {
	    name[i]=V; V+=wv5[i];
	}
	F=0;
	for (i=0; i<N2; i++)
	    F+=(wf1[i] && FV3(X,Y,Z,fe,sv,ev,rf,sce,ece,i,&v1,&v2,&v3));

	(void)fprintf(file,"ply\n"
			   "format binary_little_endian 1.0\n"
			   "element vertex %d\n"
			   "property float x\n"
			   "property float y\n"
			   "property float z\n"
			   "element face %d\n"
			   "property uchar red\n"
			   "property uchar green\n"
			   "property uchar blue\n"
			   "property list uchar int vertex_indices\n"
			   "end_header\n",V,F);

	for (i=0; i<N1; i++)
	    if (wv5[i]) {
		w=(float)X[i]; (*Put)(file,&w);
		w=(float)Y[i]; (*Put)(file,&w);
		w=(float)Z[i]; (*Put)(file,&w);
            }

	for (i=0; i<N2; i++)
	    if (wf1[i] && FV3(X,Y,Z,fe,sv,ev,rf,sce,ece,i,&v1,&v2,&v3)) {
		x=X[v1]; x1=X[v2]-x; x2=X[v3]-x;
		y=Y[v1]; y1=Y[v2]-y; y2=Y[v3]-y;
		z=Z[v1]; z1=Z[v2]-z; z2=Z[v3]-z;
		(void)fputc((y1*z2!=z1*y2)*255,file);
		(void)fputc((z1*x2!=x1*z2)*255,file);
		(void)fputc((x1*y2!=y1*x2)*255,file);

		(void)fputc(3,file); (*Put)(file,name+v1);
				     (*Put)(file,name+v2);
				     (*Put)(file,name+v3);
	    }

	if (file!=stdout) (void)fclose(file);

	return 0;
}
