
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"

extern void	Error(),RangeList();

static int	Append(i2,X,Y,x,y)
int		i2,*X,*Y,x,y;
{
	int	i1,x1,y1,x2=X[i2]-x,y2=Y[i2]-y;

	while ((i1=i2)>0) {
	    --i2; x1=x2; y1=y2; if ((x2=X[i2]-x)*y1<(y2=Y[i2]-y)*x1) break;
	}
	++i1; X[i1]=x; Y[i1]=y++; x1=0; y1=(-1);
	while ((i2=i1)>0) {
	    --i1; x2=x1; y2=y1; if ((x1=X[i1]-x)*y2<(y1=Y[i1]-y)*x2) break;
	}
	++i2; X[i2]=x; Y[i2]=y; return i2;
}

#define PV	(size_t)(Cell)(~0)

int	main(argc,argv)
int	argc;
char	**argv;
{
	int	Nx,Ny,i,*Xl,*Yl,*Xr,*Yr,y,l,x,r,L,R;
	Cell	**cell;
	char	pv[PV+1];

	if (argc!=3) Error("usage : t_ch_line orgTIFF rangeList");

	ReadImageFile(argv[1],&Nx,&Ny,NULL,&cell,NULL);

	RangeList(argv[2],PV,pv);

	i=Ny+1;
	if ((Xl=(int *)malloc(i*sizeof(*Xl)))==NULL ||
	    (Yl=(int *)malloc(i*sizeof(*Yl)))==NULL ||
	    (Xr=(int *)malloc(i*sizeof(*Xr)))==NULL ||
	    (Yr=(int *)malloc(i*sizeof(*Yr)))==NULL)
	    Error("memory allocation error.");

	i=0;
	for (y=0; y<Ny; y++) {
	    l=Nx;
	    for (x=0; x<Nx; x++)
		if (pv[cell[y][x]] && (r=x)<l) l=x;

	    if (l!=Nx)
		if (i==0) {
		    Xl[0]=Xl[1]=  l; Yl[0]=Yr[0]=y  ;
		    Xr[0]=Xr[1]= -r; Yl[1]=Yr[1]=y+1; L=R=i=1;
		}
		else {
		    L=Append(L,Xl,Yl, l,y);
		    R=Append(R,Xr,Yr,-r,y);
		}
	}
	if (i==0)
	    (void)puts("0");
	else {
	    (void)printf("%d\n",L+R+2);
            for (i=0; i<=L; i++) printf("%d\t%d\n",  Xl[i],Yl[i]);
            for (i=R; i>=0; i--) printf("%d\t%d\n",1-Xr[i],Yr[i]);
	}
	return 0;
}
