
#include <stdio.h>
#include <stdlib.h>
#include "cell.h"
#include "rif.h"

extern void	Error(char *msg),
		RangeList(char *str,size_t lim,char *obj);

static int	Append(int i2,int *X,int *Y,int x,int y)
{
	int	i1,x1,y1,x2=X[i2]-x,y2=Y[i2]-y;

	while ((i1=i2)>0) {
	    --i2; x1=x2; y1=y2; if ((x2=X[i2]-x)*y1<(y2=Y[i2]-y)*x1) break;
	}
	++i1; X[i1]=x; Y[i1]=y++; x1=0; y1=(-1);
	while ((i2=i1)>0) {
	    --i1; x2=x1; y2=y1; if ((x1=X[i1]-x)*y2<(y1=Y[i1]-y)*x2) break;
	}
	++i2; X[i2]=x; Y[i2]=y; return i2;
}

#define PV	(size_t)(Cell)(~0)

typedef struct {
		int     L,R,*Xl,*Yl,*Xr,*Yr;
	} Table;

int	main(int argc,char **argv)
{
	int		Nx,Ny,n,i,y,x,j;
	Cell		**cell,c;
	static char	object[PV+1];
	static int	L[PV+1],R[PV+1];
	static Table	*T[PV+1];
	static Cell	S[PV+1];
	Table		*t;

	if (argc!=3) Error("usage : t_chs TIFF rangeList");

	ReadImageFile(argv[1],&Nx,&Ny,NULL,&cell,NULL);

	RangeList(argv[2],PV,object);

	n=0;
	for (i=0; i<=PV; i++) {
	    L[i]=Nx; T[i]=NULL;
	}
	for (y=0; y<Ny; y++) {
	    for (x=0; x<Nx; x++)
		if (object[c=cell[y][x]]) {
		    R[c]=x; if (L[c]==Nx) L[S[n++]=c]=x;
		}

	    while (n>0) {
		if ((t=T[c=S[--n]])==NULL) {
		    if ((t=T[c]=(Table *)malloc(sizeof(Table)))==NULL ||
			(t->Xl=(int *)malloc(sizeof(int)*(i=Ny+1-y)))==NULL ||
			(t->Yl=(int *)malloc(sizeof(int)*i))==NULL ||
			(t->Xr=(int *)malloc(sizeof(int)*i))==NULL ||
			(t->Yr=(int *)malloc(sizeof(int)*i))==NULL)
			Error("memory allocation error.");

		    t->L=t->R=1;
		    t->Xl[0]=t->Xl[1]=  L[c]; t->Yl[0]=t->Yr[0]=y  ;
		    t->Xr[0]=t->Xr[1]= -R[c]; t->Yl[1]=t->Yr[1]=y+1;
		}
		else {
		    t->L=Append(t->L,t->Xl,t->Yl, L[c],y);
		    t->R=Append(t->R,t->Xr,t->Yr,-R[c],y);
		}
		L[c]=Nx;
	    }
	}
	for (i=0; i<=PV; i++)
	    if ((t=T[i])!=NULL) {
		(void)printf("%d\t%d\n",i,t->L+t->R+2);
		for (j=0; j<=t->L; j++) printf("%d\t%d\n",  t->Xl[j],t->Yl[j]);
		for (j=t->R; j>=0; j--) printf("%d\t%d\n",1-t->Xr[j],t->Yr[j]);
	    }

	return 0;
}
